@echo off
cls
rem
rem Find the application home.
rem
if "%OS%"=="Windows_NT" goto nt

echo This is not NT, so please edit this script and set _APP_HOME manually
set _APP_HOME=.

:nt
rem %~dp0 is name of current script under NT
set _APP_HOME=%~dp0

SET OLDJAVA_HOME=%JAVA_HOME%
SET OLDRMIPORT=%RMIPORT%
SET RMIPORT=1099


if not exist build.properties goto run
rem *********************************************
rem *  Init build.properties parameters
rem *********************************************

find "jdk.dir" < build.properties > jdk.dir.txt
for /F "tokens=1,2* delims==" %%i in (jdk.dir.txt) do SET JAVA_HOME=%%j
del jdk.dir.txt>nul

find "rmiport" < build.properties > rmiport.txt
for /F "tokens=1,2* delims==" %%i in (rmiport.txt) do SET RMIPORT=%%j
del rmiport.txt>nul


:run
if %SYSTEMROOT% == "" goto error
if X%1==X goto start
if %1==-jdk.dir goto jdkdir
if %1==-rmiport goto rmiport
if %1==-help goto help
goto errorpatameter

:start
if not exist %JAVA_HOME%\lib\tools.jar goto errorjava
if exist build.properties del build.properties
echo jdk.dir=%JAVA_HOME%>build.properties
echo rmiport=%RMIPORT%>>build.properties

set OLDCLASSPATH=%CLASSPATH%
set OLDPATH=%PATH%

set CLASSPATH=%_APP_HOME%\lib\ant.jar
set CLASSPATH=%CLASSPATH%;%JAVA_HOME%\lib\tools.jar

set PATH=%JAVA_HOME%\bin
java org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT%

set PATH=%OLDPATH%
set CLASSPATH=%OLDCLASSPATH%
set OLDCLASSPATH=
set OLDPATH=
goto end

:jdkdir
shift
if "X%1"=="X" goto errorjava
SET JAVA_HOME=%1
shift
if "X%1"=="X" goto start
if %1==-rmiport goto rmiport
goto errorpatameter

:rmiport
shift
if "X%1"=="X" SET RMIPORT=1099
SET RMIPORT=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
goto errorpatameter



:errorpatameter
echo.
echo     Invalid parameter value
echo.
pause
goto end

:error
echo.
echo          Enviroment variable SYSTEMROOT does not exist.
echo.
echo Set variable SYSTEMROOT to system root of your Windows installation ...
echo.
pause
goto end

:errorjava
echo.
echo     Enviroment variable JAVA_HOME mid not be set right.
echo.
echo Set variable JAVA_HOME to java root folder on your system!
echo.
pause
goto end

rem *********************************************************
rem *  Display HELP message
rem *********************************************************
:help
echo.
echo Parameters value for using with configure.bat :
echo.
echo configure       - Make build.properties file with default values
echo.
echo configure -help - Display this screen
echo.
echo configure [-jdk.dir java_directory] [-rmiport rmi_port]
echo.
echo.
echo Example:
echo.
echo configure -jdk.dir C:\j2sdk1.4.1  -rmiport 1099
echo.
goto end

:end
SET JAVA_HOME=%OLDJAVA_HOME%
SET RMIPORT=%OLDRMIPORT%
SET OLDJAVA_HOME=
SET OLDRMIPORT=

