;--------------------------------
;
; This script get command line parameters:
;
; -install path_to_entray_programm
;   or
; -uninstall
;
;--------------------------------

; The name of the installer
Name "entray"

; Set to silent mode
SilentInstall silent

; The file to write
OutFile "entray.exe"

;--------------------------------

; The stuff to install
Section ""

  Call GetCmdLineParameters
  Pop $R0
  StrCmp $R0 "" error

  StrCpy $R1 $R0
  Push $R1
  Call Trim
  Pop $R1

  Push $R1  ; Input string
  Call GetFirstAndRest
  Pop $R0
  Pop $R1
  Pop $R2

  StrCmp $R0 "-install" install
  StrCmp $R0 "-uninstall" uninstall
  Goto error

  install:
  StrCmp $R1 "" installerror

  Push $R1
  Call Trim
  Pop $R1

  WriteRegStr HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Run" $R1 "$R1\bin\nt\entray.bat"
  goto end

  installerror:
  MessageBox MB_OK|MB_ICONEXCLAMATION "You must enter name and path of your starting programm."
  goto end

  uninstall:
  StrCmp $R1 "" uninstallerror

	Push $R1
  Call Trim
  Pop $R1

  DeleteRegValue HKLM "SOFTWARE\Microsoft\Windows\CurrentVersion\Run" $R1
  goto end

  uninstallerror:
  MessageBox MB_OK|MB_ICONEXCLAMATION "You must enter name of your starting programm."
  goto end

  error:
  MessageBox MB_OK "You must put correct command line parameters."

  end:
SectionEnd
;--------------------------------------------------------
; GetCmdLineParameters
; input, none
; output, top of stack (replaces, with e.g. whatever)
; modifies no other variables.
;--------------------------------------------------------
 Function GetCmdLineParameters

   Push $R0
   Push $R1
   Push $R2
   Push $R3

   StrCpy $R2 1
   StrLen $R3 $CMDLINE

   ;Check for quote or space
   StrCpy $R0 $CMDLINE $R2
   StrCmp $R0 '"' 0 +3
     StrCpy $R1 '"'
     Goto loop
   StrCpy $R1 " "

   loop:
     IntOp $R2 $R2 + 1
     StrCpy $R0 $CMDLINE 1 $R2
     StrCmp $R0 $R1 get
     StrCmp $R2 $R3 get
     Goto loop

   get:
     IntOp $R2 $R2 + 1
     StrCpy $R0 $CMDLINE 1 $R2
     StrCmp $R0 " " get
     StrCpy $R0 $CMDLINE "" $R2

   Pop $R3
   Pop $R2
   Pop $R1
   Exch $R0

 FunctionEnd
;------------------------------------------------------------
; Remove leading and trailing whitespaces from a string
;------------------------------------------------------------
Function Trim
	Exch $R1 ; Original string
	Push $R2

Loop:
	StrCpy $R2 "$R1" 1
	StrCmp "$R2" " " TrimLeft
	StrCmp "$R2" "$\r" TrimLeft
	StrCmp "$R2" "$\n" TrimLeft
	StrCmp "$R2" "	" TrimLeft ; this is a tab.
	GoTo Loop2
TrimLeft:
	StrCpy $R1 "$R1" "" 1
	Goto Loop

Loop2:
	StrCpy $R2 "$R1" 1 -1
	StrCmp "$R2" " " TrimRight
	StrCmp "$R2" "$\r" TrimRight
	StrCmp "$R2" "$\n" TrimRight
	StrCmp "$R2" "	" TrimRight ; this is a tab
	GoTo Done
TrimRight:
	StrCpy $R1 "$R1" -1
	Goto Loop2

Done:
	Pop $R2
	Exch $R1
FunctionEnd
;----------------------------------------------------------------
; Get first part and rest of string
;----------------------------------------------------------------
Function GetFirstAndRest
  Exch $R0
  Push $R1
  Push $R2
  Push $R3
  StrLen $R3 $R0
  StrLen $R1 $R0
  IntOp $R1 $R1 + 1
  loop:
    IntOp $R1 $R1 - 1
    StrCpy $R2 $R0 1 -$R1
    StrCmp $R1 "0" exit2
    StrCmp $R2 "" exit2
    StrCmp $R2 " " exit1 ; Change " " for different strings
  Goto loop
  exit1:
    IntOp $R2 $R3 - $R1
    IntOp $R1 $R1 - 1
    StrCpy $R1 $R0 $R3 $R2
    StrCpy $R0 $R0 $R2
  exit2:
  Pop $R3
  Pop $R2
  Exch $R1
  Exch
  Exch $R0
FunctionEnd
