@echo off
cls
rem
rem Find the application home.
rem
if "%OS%"=="Windows_NT" goto nt

echo This is not NT, so please edit this script and set _APP_HOME manually
set _APP_HOME=..

:nt
rem %~dp0 is name of current script under NT
set _APP_HOME=%~dp0
rem : operator works similar to make : operator
set _APP_HOME=%_APP_HOME:\entray\=%

SET OLDJAVA_HOME=%JAVA_HOME%
SET OLDPORT=%PORT%
SET OLDNAMINGPORT=%NAMINGPORT%
SET OLDSERVICENAME=%SERVICENAME%
SET PORT=9000
SET NAMINGPORT=1099
SET SERVICENAME=Enhydra

if not exist build.properties goto run
rem *********************************************
rem *  Init build.properties parameters
rem *********************************************
find "jdk.dir" < build.properties > jdk.dir.txt
for /F "tokens=1,2* delims==" %%i in (jdk.dir.txt) do SET JAVA_HOME=%%j
del jdk.dir.txt>nul
find "port" < build.properties > port.txt
for /F "tokens=1,2* delims==" %%i in (port.txt) do SET PORT=%%j
del port.txt>nul
find "namingport" < build.properties > namingport.txt
for /F "tokens=1,2* delims==" %%i in (namingport.txt) do SET NAMINGPORT=%%j
del namingport.txt>nul
find "servicename" < build.properties > servicename.txt
for /F "tokens=1,2* delims==" %%i in (servicename.txt) do SET SERVICENAME=%%j
del servicename.txt>nul

:run
if %SYSTEMROOT% == "" goto error
if X%1==X goto start
if %1==-jdk.dir goto jdkdir
if %1==-port goto port
if %1==-namingport goto namingport
if %1==-servicename goto servicename
if %1==-help goto help
goto errorpatameter

:start
if not exist %JAVA_HOME%\lib\tools.jar goto errorjava
if exist build.properties del build.properties
echo jdk.dir=%JAVA_HOME%>build.properties
echo namingport=%NAMINGPORT%>>build.properties
echo port=%PORT%>>build.properties
echo servicename=%SERVICENAME%>>build.properties

set OLDCLASSPATH=%CLASSPATH%
set OLDPATH=%PATH%

set CLASSPATH=%_APP_HOME%\multiserver\enhydra\lib\build\ant.jar
set CLASSPATH=%CLASSPATH%;%JAVA_HOME%\lib\tools.jar

set PATH=%JAVA_HOME%\bin
java org.apache.tools.ant.Main -DSYSTEMROOT=%SYSTEMROOT%

set PATH=%OLDPATH%
set CLASSPATH=%OLDCLASSPATH%
set OLDCLASSPATH=
set OLDPATH=
goto end

:jdkdir
shift
if "X%1"=="X" goto errorjava
SET JAVA_HOME=%1
shift
if "X%1"=="X" goto start
if %1==-port goto port
if %1==-namingport goto namingport
if %1==-servicename goto servicename
goto errorpatameter

:port
shift
if "X%1"=="X" SET PORT=9000
SET PORT=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-namingport goto namingport
if %1==-servicename goto servicename
goto errorpatameter

:namingport
shift
if "X%1"=="X" SET NAMINGPORT=1099
SET NAMINGPORT=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-port goto port
if %1==-servicename goto servicename
goto errorpatameter

:servicename
shift
if "X%1"=="X" SET SERVICENAME=Enhydra
SET SERVICENAME=%1
shift
if "X%1"=="X" goto start
if %1==-jdk.dir goto jdkdir
if %1==-namingport goto namingport
if %1==-port goto port
goto errorpatameter

:errorpatameter
echo.
echo     Invalid parameter value
echo.
pause
goto end

:error
echo.
echo          Enviroment variable SYSTEMROOT does not exist.
echo.
echo Set variable SYSTEMROOT to system root of your Windows installation ...
echo.
pause
goto end

:errorjava
echo.
echo     Enviroment variable JAVA_HOME mid not be set right.
echo.
echo Set variable JAVA_HOME to java root folder on your system!
echo.
pause
goto end

rem *********************************************************
rem *  Display HELP message
rem *********************************************************
:help
echo.
echo Parameters value for using with configure.bat :
echo.
echo configure       - Make build.properties file with default values
echo.
echo configure -help - Display this screen
echo.
echo configure [-jdk.dir java_directory] [-port connecting_port] [-namingport naming_port] [-servicename service_name]
echo.
echo.
echo Example:
echo.
echo configure -jdk.dir C:\j2sdk1.4.1 -port 9000 -namingport 1099 -servicename Enhydra
echo.
goto end

:end
SET JAVA_HOME=%OLDJAVA_HOME%
SET PORT=%OLDPORT%
SET NAMINGPORT=%OLDNAMINGPORT%
SET SERVICENAME=%OLDSERVICENAME%
SET OLDJAVA_HOME=
SET OLDPORT=
SET OLDNAMINGPORT=
SET OLDSERVICENAME=
